---
title: MutationObserver.observe()
slug: Web/API/MutationObserver/observe
tags:
  - API
  - Attribute Changes
  - Changes
  - DOM
  - DOM Changes
  - DOM WHATWG
  - Element Changes
  - Method
  - Mutation Observer
  - Mutation Observer API
  - MutationObserver
  - Node Changes
  - Reference
  - observe
---
<div>{{APIRef("DOM WHATWG")}}</div>

<p><span class="seoSummary">The {{domxref("MutationObserver")}} method <code><strong>observe()</strong></code> configures the <code>MutationObserver</code> callback to begin receiving notifications of changes to the DOM that match the given options.</span> Depending on the configuration, the observer may watch a single {{domxref("Node")}} in the DOM tree, or that node and some or all of its descendant nodes.</p>

<p>To stop the <code>MutationObserver</code> (so that none of its callbacks will be triggered any longer), call {{domxref("MutationObserver.disconnect()")}}.</p>

<ul>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>mutationObserver</var>.observe(<var>target</var>, <var>options</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>target</var></code></dt>
 <dd>A DOM {{domxref("Node")}} (which may be an {{domxref("Element")}}) within the DOM tree to watch for changes, or to be the root of a subtree of nodes to be watched.</dd>
 <dt><code><var>options</var></code></dt>
 <dd>A {{domxref("MutationObserverInit")}} object providing options that describe which DOM mutations should be reported to <code><var>mutationObserver</var></code>’s <code><var>callback</var></code>. At a minimum, one of <code>childList</code>, <code>attributes</code>, and/or <code>characterData</code> must be <code>true</code> when you call {{domxref("MutationObserver.observe", "observe()")}}. Otherwise, a <code>TypeError</code> exception will be thrown.</dd>
 <dd>Options are as follows:
 <dl>
  <dt>{{domxref("MutationObserverInit.subtree", "subtree")}} {{optional_inline}}</dt>
  <dd>Set to <code>true</code> to extend monitoring to the entire subtree of nodes rooted at <code>target</code>. All of the other <code>MutationObserverInit</code> properties are then extended to all of the nodes in the subtree instead of applying solely to the <code>target</code> node. The default value is <code>false</code>.</dd>
  <dt>{{domxref("MutationObserverInit.childList", "childList")}} {{optional_inline}}</dt>
  <dd>Set to <code>true</code> to monitor the target node (and, if <code>subtree</code> is <code>true</code>, its descendants) for the addition of new child nodes or removal of existing child nodes. The default value is <code>false</code>.</dd>
  <dt>{{domxref("MutationObserverInit.attributes", "attributes")}} {{optional_inline}}</dt>
  <dd>Set to <code>true</code> to watch for changes to the value of attributes on the node or nodes being monitored. The default value is <code>true</code> if either of <code>attributeFilter</code> or <code>attributeOldValue</code> is specified, otherwise the default value is <code>false</code>.</dd>
  <dt>{{domxref("MutationObserverInit.attributeFilter", "attributeFilter")}} {{optional_inline}}</dt>
  <dd>An array of specific attribute names to be monitored. If this property isn't included, changes to all attributes cause mutation notifications.</dd>
  <dt>{{domxref("MutationObserverInit.attributeOldValue", "attributeOldValue")}} {{optional_inline}}</dt>
  <dd>Set to <code>true</code> to record the previous value of any attribute that changes when monitoring the node or nodes for attribute changes; see {{SectionOnPage("/en-US/docs/Web/API/MutationObserver", "Monitoring attribute values")}} for details on watching for attribute changes and value recording. The default value is <code>false</code>.</dd>
  <dt>{{domxref("MutationObserverInit.characterData", "characterData")}} {{optional_inline}}</dt>
  <dd>Set to <code>true</code> to monitor the specified target node (and, if <code>subtree</code> is <code>true</code>, its descendants) for changes to the character data contained within the node or nodes. The default value is <code>true</code> if <code>characterDataOldValue</code> is specified, otherwise the default value is <code>false</code>.</dd>
  <dt>{{domxref("MutationObserverInit.characterDataOldValue", "characterDataOldValue")}} {{optional_inline}}</dt>
  <dd>Set to <code>true</code> to record the previous value of a node's text whenever the text changes on nodes being monitored. For details and an example, see {{SectionOnPage("/en-US/docs/Web/API/MutationObserver", "Monitoring text content changes")}}. The default value is <code>false</code>.</dd>
 </dl>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>{{jsxref('TypeError')}}</dt>
 <dd>Thrown in any of the following circumstances:
 <ul>
  <li>The <code><var>options</var></code> are configured such that nothing will actually be monitored. <br>
   (For example, if {{domxref("MutationObserverInit.childList")}}, {{domxref("MutationObserverInit.attributes")}}, and {{domxref("MutationObserverInit.characterData")}} are all <code>false</code>.)</li>
  <li>The value of <code><var>options.</var>attributes</code> is <code>false</code> (indicating that attribute changes are not to be monitored), but <code>attributeOldValue</code> is <code>true</code> and/or <code>attributeFilter</code> is present.</li>
  <li>The {{domxref("MutaitonObserverInit.characterDataOldValue", "characterDataOldValue")}} option is <code>true</code> but {{domxref("MutationObserverInit.characterData")}} is <code>false</code> (indicating that character changes are not to be monitored).</li>
 </ul>
 </dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Reusing_MutationObservers">Reusing MutationObservers</h3>

<p>You can call <code>observe()</code> multiple times on the same <code>MutationObserver</code> to watch for changes to different parts of the DOM tree and/or different types of changes. There are some caveats to note:</p>

<ul>
 <li>If you call <code>observe()</code> on a node that's already being observed by the same <code>MutationObserver</code>, all existing observers are automatically removed from all targets being observed before the new observer is activated.</li>
 <li>If the same <code>MutationObserver</code> is not already in use on the target, then the existing observers are left alone and the new one is added.</li>
</ul>

<h3 id="Observation_follows_nodes_when_disconnected">Observation follows nodes when disconnected</h3>

<p>Mutation observers are intended to let you be able to watch the desired set of nodes over time, even if the direct connections between those nodes are severed. If you begin watching a subtree of nodes, and a portion of that subtree is detached and moved elsewhere in the DOM, you continue to watch the detached segment of nodes, receiving the same callbacks as before the nodes were detached from the original subtree.</p>

<p>In other words, until you've been notified that nodes are being split off from your monitored subtree, you'll get notifications of changes to that split-off subtree and its nodes. This prevents you from missing changes that occur after the connection is severed and before you have a chance to specifically begin monitoring the moved node or subtree for changes.</p>

<p>Theoretically, this means that if you keep track of the {{domxref("MutationRecord")}} objects describing the changes that occur, you should be able to "undo" the changes, rewinding the DOM back to its initial state.</p>

<h2 id="Example">Example</h2>

<p>In this example, we demonstrate how to call the method <code><strong>observe()</strong></code> on an instance of {{domxref("MutationObserver")}}, once it has been set up, passing it a target element and a {{domxref("MutationObserverInit")}} options object.</p>

<pre class="brush: js notranslate">// identify an element to observe
const elementToObserve = document.querySelector("#targetElementId");

// create a new instance of `MutationObserver` named `observer`,
// passing it a callback function
const observer = new MutationObserver(function() {
    console.log('callback that runs when observer is triggered');
});

// call `observe()` on that MutationObserver instance,
// passing it the element to observe, and the options object
observer.observe(elementToObserve, {subtree: true, childList: true});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-mutationobserver-observe', 'MutationObserver.observe()')}}</td>
   <td>{{ Spec2('DOM WHATWG') }}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MutationObserver.observe")}}</p>
